#include <stdio.h>
#include <stdlib.h>

#define MAX_DLUG 100

typedef struct {
	int dl;
	int t[MAX_DLUG];
} bignum;

int maxint(int a, int b)
{
	if (a>b) return a; else return b;
}

void init(bignum *a)
{
	a->dl=0;
	memset(a->t,0,sizeof(int)*MAX_DLUG);
}


void formstring (bignum *a, char *s)
{
	int i;
	init(a);
	a->dl = strlen(s);
	for (i=0; i<a->dl; i++)
	{ 
	a->t[a->dl-i-1] = s[i]-'0';
	}
}

void fromint (bignum *a, int x)
{
	char s[15];
	sprintf(s,"%d",x);
	formstring(a,s);
}

void wypisz (bignum *a)
{
	int i;
	for (i=a->dl-1; i>=0; i--)
		printf("%d",a->t[i]);
	if (!a->dl) printf("0");
	printf("\n");
}


void dodaj(bignum *a, bignum *b, bignum *c)
{
	int i;
	init(c);
	c->dl = maxint(a->dl, b->dl);
	for (i=0; i<c->dl; i++)
	{
		c->t[i] += (a->t[i] + b->t[i]);
		while (c->t[i] > 9) { c->t[i+1]++; c->t[i]-=10; }
	}
	if (c->t[c->dl]) c->dl++;
}

int comp (bignum *a, bignum *b)
{
	int i;
	if (a->dl > b->dl) return 1;
	if (a->dl < b->dl) return -1;

	for (i=a->dl-1; i>=0; i--)
	{
		if (a->t[i] > b->t[i]) return 1;
		if (a->t[i] < b->t[i]) return -1;
	}
	return 0;
}

void odejmij (bignum *a, bignum *b, bignum *c)
{
	int i;
	init(c);
	if (comp(a,b) ==-1) 
	{
		printf("proba odjecia wieksz od mniejsz!\n");
		return;
	}

	c->dl = a->dl;
	
	for (i=0; i<c->dl; i++) 
	{
		c->t[i] += (a->t[i] - b->t[i]);
		while (c->t[i] < 0) { c->t[i+1]--; c->t[i]+=10; }
	}
	while (!(c->t[c->dl-1])) { c->dl--; }
}

void mnoz_skalar (bignum *a, int x, bignum *c)
{
	int i;
	init (c);
	if (!x) return;

	c->dl = a->dl;

	for (i=0; i<c->dl; i++) {
		c->t[i] += (a->t[i] * x);
		while (c->t[i] > 9) { c->t[i+1]++; c->t[i]-=10; }
	}
	if (c->t[c->dl]) c->dl++;
}

void mnoz (bignum *a, bignum *b, bignum *c)
{
	int i,j;
	init (c);
	c->dl = a->dl + b->dl;

	for (i=0; i<a->dl; i++)
	{
		for (j=0; i<b->dl; j++) 
		{
			c->t[i+j] += (a->t[i]*b->t[j]);
			c->t[i+j+1] += (c->t[i+j] / 10);
			c->t[i+j] %= 10;
		}
	}
	while (!(c->t[c->dl-1])) { c->dl--; }
}


int main()
{
	bignum a,b,c;
	int ai,bi;
	int i;

	for (i=0; i<10 ; i++)
	{
		ai = rand()/100000;
		bi = rand()/100000;

		printf("%d   %d\n",i,ai);
		fromint(&a,ai);
		fromint(&b,bi);

		mnoz(&a,&b,&c);
		wypisz(&c);

		printf("%d\n",ai*bi);
	}

return 0;
}
